#!/bin/sh

#IMAGE_DIR="${0%/*}/"
BUILD_PATH="buildroot-2021.02.1"
IMAGE_DIR="${BUILD_PATH}/output/images"
UBOOT_IMAGE="${IMAGE_DIR}/u-boot.bin"

if [ "${1}" = "serial-only" ]; then
    EXTRA_ARGS='-nographic'
else
    EXTRA_ARGS=''
fi

export PATH="/home/yutaka/buildroot/${BUILD_PATH}/output/host/bin:${PATH}"

qemu-system-aarch64 --version

exec qemu-system-aarch64 \
     -M virt \
     -cpu cortex-a53 \
     -nographic \
     -smp 1 \
     -kernel ${IMAGE_DIR}/Image \
     -append "rootwait root=/dev/vda console=ttyAMA0" \
     -net nic \
     -net user,hostfwd=tcp::10022-:22 \
     -drive file=${IMAGE_DIR}/rootfs.ext4,if=none,format=raw,id=hd0 \
     -device virtio-blk-device,drive=hd0 \
     ${EXTRA_ARGS}

