#include <linux/module.h>
#include <linux/device.h>

#define MODULE_NAME "sample_driver"

MODULE_LICENSE("GPL");
MODULE_DESCRIPTION("This is a sample driver.");
MODULE_AUTHOR("Yutaka Hirata");

struct sample_driver {
	struct device_driver driver;
};

static int sample_init(struct sample_driver *drv)
{
	float n;
	unsigned int val = 0;

	n = 1000.0 / 30.0;
	memcpy(&val, &n, sizeof(n));

	printk("driver loaded\n");
	printk("%f\n", n);
	printk("%x\n", val);

	return 0;
}

static void sample_exit(struct sample_driver *drv)
{
	printk("driver unloaded\n");
}

static struct sample_driver sa_drv = {
	.driver = {
		.name = MODULE_NAME,
	},
};

module_driver(sa_drv, sample_init, sample_exit);

