#include <linux/module.h>
#include <linux/device.h>

#define MODULE_NAME "sample_driver"

MODULE_LICENSE("GPL");
MODULE_DESCRIPTION("This is a sample driver.");
MODULE_AUTHOR("Yutaka Hirata");

struct sample_driver {
	struct device_driver driver;
};

static int sample_init(struct sample_driver *drv)
{
	char buf[128] = {
		'a', 'b', 'c', 'd', 0, '1', '2', '3',
		[63] = 'z',
		[64] = 'y', 'x', 'w', 'v',
	};

	printk("%ph\n", buf);
	printk("%*ph\n", 4, buf);
	printk("%*phC\n", 8, buf);
	printk("%*phD\n", 8, buf);
	printk("%*phN\n", 8, buf);

	printk("%*phC\n", 128, buf);

	print_hex_dump(KERN_INFO, 
			"Y ", DUMP_PREFIX_OFFSET, 
			16, 1, buf, sizeof(buf), true);

	return 0;
}

static void sample_exit(struct sample_driver *drv)
{
	printk("driver unloaded\n");
}

static struct sample_driver sa_drv = {
	.driver = {
		.name = MODULE_NAME,
	},
};

module_driver(sa_drv, sample_init, sample_exit);

