#include <linux/module.h>
#include <linux/device.h>
#include <linux/ioport.h>

#define MODULE_NAME "sample_driver"

MODULE_LICENSE("GPL");
MODULE_DESCRIPTION("This is a sample driver.");
MODULE_AUTHOR("Yutaka Hirata");

struct sample_driver {
	struct device_driver driver;
};

static int sample_init(struct sample_driver *drv)
{
	struct resource res;

	memset(&res, 0, sizeof(res));
	res.start = 0;
	res.end = 0x1000;
	res.name = "test";
	res.flags = IORESOURCE_MEM | IORESOURCE_DMA;

	printk("%pR\n", &res);
	printk("%pr\n", &res);

	return 0;
}

static void sample_exit(struct sample_driver *drv)
{
	printk("driver unloaded\n");
}

static struct sample_driver sa_drv = {
	.driver = {
		.name = MODULE_NAME,
	},
};

module_driver(sa_drv, sample_init, sample_exit);

