#include <linux/module.h>
#include <linux/device.h>

#define MODULE_NAME "sample_driver"

MODULE_LICENSE("GPL");
MODULE_DESCRIPTION("This is a sample driver.");
MODULE_AUTHOR("Yutaka Hirata");

struct sample_driver {
	struct device_driver driver;
};

typedef void (*func_ptr_t)(void);

static void sub1(void)
{
	printk("%s\n", __func__);
}

static void sub2(void)
{
	printk("%s\n", __func__);
}

static int sample_init(struct sample_driver *drv)
{
	func_ptr_t func[] = {
		sub1,
		sub2,
		NULL,
	};
	func_ptr_t *p = func;

	while (*p) {
		if (*p) {
			(*p)();

			printk("Pointer %p\n", *p);
			printk("Symbol Pointer %pS\n", *p);

		} else {
			break;
		}

		p++;
	}

	return 0;
}

static void sample_exit(struct sample_driver *drv)
{
	printk("driver unloaded\n");
}

static struct sample_driver sa_drv = {
	.driver = {
		.name = MODULE_NAME,
	},
};

module_driver(sa_drv, sample_init, sample_exit);

