#include <linux/module.h>
#include <linux/device.h>
#include <linux/rtc.h>

#define MODULE_NAME "sample_driver"

MODULE_LICENSE("GPL");
MODULE_DESCRIPTION("This is a sample driver.");
MODULE_AUTHOR("Yutaka Hirata");

struct sample_driver {
	struct device_driver driver;
};

static int sample_init(struct sample_driver *drv)
{
	struct rtc_time rtm = {
		.tm_sec = 7,
		.tm_min = 41,
		.tm_hour = 8,
		.tm_mday = 8,
		.tm_mon = 5-1,
		.tm_year = 2021-1900,
		.tm_wday = 6,
	};
	time64_t tick = 1620463267;

	printk("%ptR\n", &rtm);
	printk("%ptT\n", &tick);

	return 0;
}

static void sample_exit(struct sample_driver *drv)
{
	printk("driver unloaded\n");
}

static struct sample_driver sa_drv = {
	.driver = {
		.name = MODULE_NAME,
	},
};

module_driver(sa_drv, sample_init, sample_exit);

