/*
 *
 * aarch64-buildroot-linux-uclibc-gcc -Wall rapp.c -o rapp
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

#define DEVFILE "/dev/samplehw"

int main(int argc, char **argv)
{
	int fd;
	ssize_t ret;
	char buf[64];
	int i, buflen;
	int read_size;

	buflen = sizeof(buf);
	read_size = buflen;
	if (argc == 2) {
		i = atoi(argv[1]);
		if (i < buflen) {
			read_size = i;
		}
	}

	fd = open(DEVFILE, O_RDWR);
	if (fd == -1) {
		perror("open");
		exit(1);
	}

	printf("reading %d bytes...\n", read_size);
	ret = read(fd, buf, read_size);
	if (ret == -1) {
		perror("read");
	}
	printf("read size %zd\n", ret);
	for (i = 0 ; i < ret ; i++) {
		printf("%c", buf[i]);
	}
	printf("\n");

	close(fd);

	return 0;
}

