/*
 *
 * aarch64-buildroot-linux-uclibc-gcc -Wall iapp.c -o iapp
 * arm-linux-gcc iapp.c -static -o iapp32
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include "sample.h"

#define DEVFILE "/dev/samplehw"

int main(int argc, char **argv)
{
	int fd;
	int ret;
	int val;
	struct sample_data_cmd dcmd;

	fd = open(DEVFILE, O_RDWR);
	if (fd == -1) {
		perror("open");
		exit(1);
	}

	val = 0;
	ret = ioctl(fd, READCMD, &val);
	if (ret) {
		printf("READCMD: ioctl error: %d\n", ret);
	} else {
		printf("READCMD: val %x\n", val);
	}
	
	val = 0x1234abcd; 
	ret = ioctl(fd, WRITECMD, &val);
	if (ret) {
		printf("WRITECMD: ioctl error: %d\n", ret);
	} else {
		printf("WRITECMD: success\n");
	}

	dcmd.mask = 0xfe;
	dcmd.val = ~0;
	printf("sizeof %zu\n", sizeof(dcmd));
	ret = ioctl(fd, DATACMD, &dcmd);
	if (ret) {
		printf("DATACMD: ioctl error: %d\n", ret);
	} else {
		printf("DATACMD: success\n");
	}

	close(fd);

	return 0;
}


