#!/bin/sh

#IMAGE_DIR="${0%/*}/"
IMAGE_DIR="buildroot-2021.02_efi/output/images"

if [ "${1}" = "serial-only" ]; then
    EXTRA_ARGS='-nographic'
else
    EXTRA_ARGS=''
fi

export PATH="/home/yutaka/buildroot/buildroot-2021.02_efi/output/host/bin:${PATH}"

qemu-system-aarch64 --version

exec qemu-system-aarch64 \
    -M virt \
    -cpu cortex-a57 \
    -m 512 \
    -nographic \
    -bios uefi/2021_QEMU_EFI.fd \
    -drive file=${IMAGE_DIR}/disk.img,if=none,format=raw,id=hd0 \
    -device virtio-blk-device,drive=hd0 \
    -netdev user,id=eth0,hostfwd=tcp::10022-:22 \
    -device virtio-net-device,netdev=eth0 \
    -object rng-random,filename=/dev/urandom,id=rng0 \
    -device virtio-rng-pci,rng=rng0 \
    ${EXTRA_ARGS}

